
sub auth_check_password {

	my ($pass, @passwd, $userid, $pw, @permissions, $file, $uid);
	my ($server_auth) = $ENV{'REMOTE_USER'} || $ENV{'AUTH_USER'};
	 
	if ($auth_no_authentication || (($db_uid eq 'default') && $auth_allow_default)) {		
		return ('ok', 'default', @auth_default_permissions);
	}
	elsif ($server_auth) {   # The user has logged in via server authentication.
		return ('ok', $server_auth, &auth_check_permissions($server_auth));
	}
	elsif ($in{'login'}) {
		open (PASSWD, "<$auth_pw_file") || &cgierr("unable to open password file. Reason: $!\n");
			@passwds = <PASSWD>;			
		close PASSWD;
		my ($view, $add, $mod, $del, $admin);
		PASS: foreach $pass (@passwds) {	# Go through each pass and see if we match..
			next PASS if ($pass =~ /^$/);	
			next PASS if ($pass =~ /^#/);
			chomp ($pass);
			($userid, $pw, $view, $add, $del, $mod, $admin) = split (/:/, $pass);
			if (($in{'userid'} eq $userid) && (crypt($in{'pw'}, $pw) eq $pw)) {		
				srand( time() ^ ($$ + ($$ << 15)) );
				$db_uid = "$userid." . time() . (int(rand(100000)) + 1);
				open(AUTH, ">$auth_dir/$db_uid") or &cgierr("unable to open auth file: $auth_dir/$uid. Reason: $!\n");
					print AUTH "$uid: $ENV{'REMOTE_HOST'}\n";
				close AUTH;
				foreach (0 .. 3) { $permissions[$_] = int($permissions[$_]); }
				&auth_logging('logged on', $userid) if ($auth_logging);
				return ('ok', $db_uid, $view, $add, $del, $mod, $admin);
			}
		}
		return ("invalid username/password");
	}
	elsif ($db_uid) { 
		(-e "$auth_dir/$db_uid") ?
			return ('ok', $db_uid, &auth_check_permissions($db_uid)) :
			return ('invalid/expired user session');	
	}
	else {	
		return 'no login';
	}
}

sub auth_check_permissions {

	my ($userid) = shift;
	my ($username, @permissions, $permission, $name, $pw, $view, $add, $del, $mod, $admin);

	if ($auth_no_authentication || (($userid eq 'default') && $auth_allow_default)) {
		return (@auth_default_permissions);
	}

	if ($ENV{'REMOTE_USER'} || $ENV{'AUTH_USER'}) {
		$username = $ENV{'REMOTE_USER'} || $ENV{'AUTH_USER'};
	}
	else {
		($userid =~ /^([A-Za-z0-9]+)\.\d+$/) ? ($username = $1) : return (0,0,0,0,0);
		unlink "$auth_dir/$userid";
  		open(AUTH, ">$auth_dir/$userid") or &cgierr("unable to open auth file: $auth_dir/$userid. Reason: $!\n");
    		print AUTH "$userid: $ENV{'REMOTE_HOST'}\n";
  		close AUTH;
	}

	open (PER, "<$auth_pw_file") or &cgierr("unable to open password file. Reason: $!");
		@permissions = <PER>;
	close PER;

	PER: foreach $permission (@permissions) {
		($permission =~ /^$/) and next PER;	
		($permission =~ /^#/) and next PER;	
		($name, $pw, $view, $add, $del, $mod, $admin) = split (/:/, $permission);			
		if ($username eq $name) {
			$view = int($view); $add = int($add); 
			$del = int($del); $mod = int($mod); 	
			$admin = int($admin);
			return ($view, $add, $del, $mod, $admin);
		}
	}
	return (0,0,0,0,0);	
}

sub auth_logging {

	my ($action, $uid) = @_;
	my ($time) = &get_time;		
	my ($date) = &get_date(time());	
	if (!$uid) {
		$db_userid ?
			($uid = $db_userid) :
			($uid = "UNKNOWN");
	}	
	open (LOG, ">>$auth_log_file") || &cgierr("unable to open log file: $auth_log_file. Reason: $!\n");
		flock (LOG, 2) unless (!$db_use_flock);
		print LOG "$uid $action at $time on $date from $ENV{'REMOTE_HOST'}\n";		
	close AUTH;		
}


sub auth_cleanup {

	my (@files);
	
	opendir (AUTHDIR, "$auth_dir") || &cgierr("unable to open directory in auth_cleanup: $auth_dir. Reason: $!");
		@files = readdir(AUTHDIR);			
	closedir (AUTHDIR);
	FILE: foreach $file (@files) {
		next if ($file =~ /^\./);
		next if ($file =~ /^index/);
		if ((stat("$auth_dir/$file"))[9] + $auth_time < time) {
			unlink ("$auth_dir/$file");		
		}
	}
}

1;	