#!/usr/bin/perl

$db_script_path = ".";
use CGI;
$query = new CGI;

local(%in) = &parse_form;
$in{'db'}  ? ($db_setup = $in{'db'}) : ($db_setup = 'default');
$in{'uid'} ? ($db_uid   = $in{'uid'}): ($db_uid   = '');

eval {
	unshift (@INC, $db_script_path);
	require 5.003;				
	unless ($db_setup =~ /^[A-Za-z0-9]+$/) { die "Invalid config file name: $db_setup"; }
	require "$db_setup.cfg";	
	require "auth.pl";			
};
if ($@) { &cgierr ("Error loading required libraries.\nCheck that they exist, permissions are set correctly and that they compile.\nReason: $@"); }

if ($db_benchmark) { $t0 = new Benchmark; }

eval { &main; };
if ($@) { &cgierr("fatal error: $@"); }

if ($db_benchmark) { $t1 = new Benchmark; print "<h6>Processing Time: " . timestr(timediff($t1, $t0)) . "</h6>"; }

&cgierr("Debug Information") if ($db_debug);

exit; 	

sub main {
# --------------------------------------------------------
	my ($status, $uid);
	local($per_add, $per_view, $per_mod, $per_del, $per_admin);	

	$|++;		# Flush Output Right Away

	&auth_cleanup unless ($auth_no_authentication);	 

	($status, $uid, $per_view, $per_add, $per_del, $per_mod, $per_admin) 
			= &auth_check_password;	     

	if ($status eq "ok") {

		$db_script_link_url = "$db_script_url?db=$db_setup&uid=$db_uid";
		if ($uid eq "default") { $db_userid = $uid; }
		else { ($db_userid) = $db_uid =~ /([A-Za-z0-9]+)\.\d+/; }		
					
		if    ($in{'add_form'})			{ if ($per_add) { &html_add_form; } 		  else { &html_unauth; } }
		elsif ($in{'topten'}) 			{ if ($per_view) { &html_topten; }   			  else { &html_unauth; } }
		elsif ($in{'whos_online'}) 			{ if ($per_view) { &html_whos_online; } 		  else { &html_unauth; } }
		elsif ($in{'add_record'})			{ if ($per_add) { &add_record; } 			  else { &html_unauth; } }
		elsif ($in{'view_search'})			{ if ($per_view) { &html_view_search; } 	 	  else { &html_unauth; } }
		elsif ($in{'view_records'})			{ if ($per_view) { &view_records; } 		  else { &html_unauth; } } 
		elsif ($in{'delete_search'})			{ if ($per_del) { &html_delete_search; } 	  	  else { &html_unauth; } }  
		elsif ($in{'delete_form'})			{ if ($per_del) { &html_delete_form; }		  else { &html_unauth; } }  
		elsif ($in{'delete_records'})		{ if ($per_del) { &delete_records; } 		    	  else { &html_unauth; } }  
		elsif ($in{'modify_search'})		{ if ($per_mod) { &html_modify_search; } 	  	  else { &html_unauth; } }  
		elsif ($in{'modify_form'})			{ if ($per_mod) { &html_modify_form; }		  else { &html_unauth; } }  
		elsif ($in{'modify_form_record'})		{ if ($per_mod) { &html_modify_form_record; } 	  else { &html_unauth; } }  
		elsif ($in{'modify_record'})			{ if ($per_mod) { &modify_record;  } 		  else { &html_unauth; } }
		elsif ($in{'admin_display'})			{ if ($per_admin) { &admin_display; }		  else { &html_unauth; } }
		elsif ($in{'logoff'})  { &auth_logging('logged off') if ($auth_logging);
                         						unlink "$auth_dir/$db_uid";
                         						$auth_logoff ? (print "Location: $auth_logoff\n\n") : (print "Location: $db_script_url\n\n"); }
		elsif ((keys(%in) <= 2) || 
				($in{'login'}))				{ &html_home; }
		else 								{ &html_unkown_action; }		
	}

	elsif ($auth_signup and $in{'signup_form'}) {
		&html_signup_form; 
	}
	elsif ($auth_signup and $in{'signup'}) {
		&signup; 
	}

	elsif ($status eq "no login") {
		&html_login_form;
	}

	else {
		&html_login_failure($status);
	}
}

sub validate_upload {
# --------------------------------------------------------
  my ($filekey,$filename,$newfilename,$extlength,$filehandle,$totalbytes,$buffer,$bytes,@extensions,@ext);

  $| = 1; 

  $filekey = $query->param("Filename");
  $newfilename = $in{$db_key};

  if (!(-e $SAVE_DIRECTORY)) {
    return "The directory doesn't exist. Make sure that this directory is a complete path name,<BR>
	        not a URL or something similar. It should look similar to<BR>
		    /home/username/public_html/uploads";
  }
  if (!(-W $SAVE_DIRECTORY)) {
    return "The directory isn't writable. Make sure that this directory is writable by all users.<BR>
	        At your UNIX command prompt, type chmod 777 $SAVE_DIRECTORY";
  }
  if (!(-d $SAVE_DIRECTORY)) {
    return "The directory you specified isn't really a directory.<BR>
	        Make sure that this is indeed a directory and not a file.";
  }

  if ($filekey =~ /([^\/\\]+)$/) {
    $filename = $1;
    $extlength = length($filename) - index($filename,".");
    $filename = $newfilename . lc(substr($filename,-$extlength,$extlength));
    unless ($filename =~ /$ALLOWED_EXT/) {
      $ALLOWED_EXT =~ s/\\//g;
      $ALLOWED_EXT =~ s/\$//g;
      @ext = split (/\Q|\E/o,$ALLOWED_EXT);
      $ALLOWED_EXT = join(" or ",@ext);
      return "Only files with the following extension(s) are allowed: $ALLOWED_EXT";
    }
  } 
  else {
    return "You attempted to upload <B>$filekey</B> that isn't properly formatted. Please rename the file
    on your computer, and attempt to upload it again. Files may not have forward or backward slashes in
    their names. Also, they may not be prefixed with one (or more) periods.";
  }

  $ALLOWED_EXT =~ s/\\.//g;
  $ALLOWED_EXT =~ s/\$//g;

  foreach $extension (@extensions) {
    (-e "$SAVE_DIRECTORY/$newfilename.$extension") && (unlink "$SAVE_DIRECTORY/$newfilename.$extension")
  }
  if (!open(OUTFILE, ">$SAVE_DIRECTORY\/$filename")) {
    return "There was an error opening '$SAVE_DIRECTORY\/$filename' for Writing.\n";
  }

  binmode(OUTFILE); # This is needed to work on Windows/NT platforms.

  while ($bytes = read($filekey,$buffer,1024)) {
    $totalbytes += $bytes;
    print OUTFILE $buffer;
  }

  close($filekey);
  close(OUTFILE);

  chmod (0666, "$SAVE_DIRECTORY\/$filename");

  if ($totalbytes > $MAXIMUM_UPLOAD && $MAXIMUM_UPLOAD > 0) {
    unlink "$SAVE_DIRECTORY\/$filename";
    return "Filename<BR>
            You have reached your upload limit.<BR> 
            Your file contains <B>$BytesRead $totalbytes</B> bytes.<BR>
            This exceeds the maximum limit of <B>$MAXIMUM_UPLOAD</B> bytes.<BR>
            Your file was not saved.<BR>
            Please try again.";
  }

  return "ok";
}

sub add_record {

	my ($output, $status, $counter);

	($auth_user_field >= 0) and ($in{$db_cols[$auth_user_field]} = $db_userid);
	
	$status = &validate_record;

	while ($status eq "duplicate key error" and $db_key_track) {
		return "duplicate key error" if ($counter++ > 50);
		$in{$db_key}++;
		$status = &validate_record;
	}

	if (($status eq "ok") && ($in{'Filename'})) { $status = &validate_upload; }

 	 $ALLOWED_EXT =~ s/\\.//g;
 	 $ALLOWED_EXT =~ s/\$//g;
 	 @extensions = split (/\Q|\E/o,$ALLOWED_EXT);
 	 foreach $extension (@extensions) {
 	   if (-e "$SAVE_DIRECTORY/$in{$db_key}.$extension") {
  	    $in{'Graphic'} = 'Yes';
		  $graphic_found=1;
		}
  	}
  	unless ($graphic_found) { $in{'Graphic'} = ''; }

	if ($status eq "ok") {
		open (DB, ">>$db_file_name") or &cgierr("error in add_record. unable to open database: $db_file_name.\nReason: $!");
			if ($db_use_flock) {
				flock(DB, 2)  or &cgierr("unable to get exclusive lock on $db_file_name.\nReason: $!");
			}
			print DB &join_encode(%in);	
		close DB;		
		if ($db_key_track) {
			open (ID, ">$db_id_file_name") or &cgierr("error in get_defaults. unable to open id file: $db_id_file_name.\nReason: $!");
				if ($db_use_flock) {
					flock(ID, 2)  or &cgierr("unable to get exclusive lock on $db_id_file_name.\nReason: $!");
				}
				print ID $in{$db_key};		
			close ID;		
		}
		&auth_logging("added record: $in{$db_key}") if ($auth_logging);
		&html_add_success;
	}
	else {
		&html_add_failure($status);
	}
}

sub delete_records {

	my ($key, %delete_list, $rec_to_delete, @lines, $line, @data, $errstr, $succstr, $output, $restricted);
	$rec_to_delete = 0;
	foreach $key (keys %in) {				
		if ($in{$key} eq "delete") {
			$delete_list{$key} = 1;
			$rec_to_delete = 1;
		}
	}
	if (!$rec_to_delete) {
		&html_delete_failure("No records specified");
		return;
	}

	open (DB, "<$db_file_name") or &cgierr("error in delete_records. unable to open db file: $db_file_name.\nReason: $!");
		if ($db_use_flock) { flock(DB, 1); }
		@lines = <DB>;
	close DB;

	($restricted = 1) if ($auth_modify_own and !$per_admin);
	
	LINE: foreach $line (@lines) {
		if ($line =~ /^$/) { next LINE; }
		if ($line =~ /^#/) { $output .= $line; next LINE; }
		chomp ($line);			
		@data     = &split_decode($line);
		($output .= "$line\n" and next LINE) if ($restricted and ($db_userid ne $data[$auth_user_field]));
		
	if ($delete_list{$data[$db_key_pos]}) {         
 	 $delete_list{$data[$db_key_pos]} = 0;         
 	 if ($db_upload) {
  	  $ALLOWED_EXT =~ s/\\.//g;
  	  $ALLOWED_EXT =~ s/\$//g;
  	  @extensions = split (/\Q|\E/o,$ALLOWED_EXT);
   	 foreach $extension (@extensions) {
     	 (-e "$SAVE_DIRECTORY/$data[$db_key_pos].$extension") && (unlink "$SAVE_DIRECTORY/$data[$db_key_pos].$extension")
   	 }
 	 }
	}
	else { $output .= $line . "\n"; }

	}
	
	foreach $key (keys %delete_list) {
		$delete_list{$key} ?
			($errstr .= "$key,") :			
			($succstr .= "$key,"); 			
	}
	chop($succstr);		
	chop($errstr);		

	open (DB, ">$db_file_name") or &cgierr("error in delete_records. unable to open db file: $db_file_name.\nReason: $!");
		if ($db_use_flock) {
			flock(DB, 2) or &cgierr("unable to get exclusive lock on $db_file_name.\nReason: $!");
		}
		print DB $output;
	close DB;		

	&auth_logging("deleted records: $succstr") if ($auth_logging);
	$errstr ?
		&html_delete_failure($errstr) :		
		&html_delete_success($succstr);		
}	

sub modify_record {

	my ($status, $line, @lines, @data, $output, $found, $restricted);
	
	$db_not_null{'Filename'} = 0;	

	$status = &validate_record;

  	if (($status eq "ok") && ($in{'Filename'})) { $status = &validate_upload; }
	
  	$ALLOWED_EXT =~ s/\\.//g;
	  $ALLOWED_EXT =~ s/\$//g;
	  @extensions = split (/\Q|\E/o,$ALLOWED_EXT);
	  foreach $extension (@extensions) {
	    if (-e "$SAVE_DIRECTORY/$in{$db_key}.$extension") {
	      $in{'Graphic'} = 'Yes';
		  $graphic_found=1;
		}
	  }
	  unless ($graphic_found) { $in{'Graphic'} = ''; }

	if ($status eq "ok") {
		open (DB, "<$db_file_name") or &cgierr("error in modify_records. unable to open db file: $db_file_name.\nReason: $!");
			if ($db_use_flock) { flock(DB, 1); }
			@lines = <DB>;	
		close DB;

		($restricted = 1) if ($auth_modify_own and !$per_admin);

		$found = 0;		
		LINE: foreach $line (@lines) {
			if ($line =~ /^$/) { next LINE; }
			if ($line =~ /^#/) { $output .= $line; next LINE; }	
			chomp ($line);			
			@data     = &split_decode($line);
			($output .= "$line\n" and next LINE) if ($restricted and ($db_userid ne $data[$auth_user_field]));
			
			if ($data[$db_key_pos] eq $in{$db_key}) {

				if ($auth_user_field >= 0 and (!$per_admin or !$in{$db_cols[$auth_user_field]})) {
					$in{$db_cols[$auth_user_field]} = $data[$auth_user_field];  
				}
				$output .= &join_encode(%in);			
				$found = 1;								
			}
			else {
				$output .= $line . "\n";
			}
		}
		if ($found) {
			open (DB, ">$db_file_name") or &cgierr("error in modify_records. unable to open db file: $db_file_name.\nReason: $!");
				if ($db_use_flock) {
					flock(DB, 2)  or &cgierr("unable to get exclusive lock on $db_file_name.\nReason: $!");
				}
				print DB $output;				
			close DB;			

			&auth_logging("modified record: $in{$db_key}") if ($auth_logging);
			&html_modify_success;
		}
		else {
			&html_modify_failure("$in{$db_key} (can't find requested record)");
		}
	}
	else {
		&html_modify_failure($status);		
	}
}

sub view_records {

	my ($status, @hits) = &query("view");
	if ($status eq "ok") {
		&html_view_success(@hits);
	}
	else {
		&html_view_failure($status);
	}
}

sub query {

	my ($i, $column, @search_fields, @search_gt_fields, @search_lt_fields, $maxhits, $numhits, $nh,
	    $field, @regexp, $line, @values, $key_match, @hits, @sortedhits, $next_url, $next_hit, $prev_hit,
		$first, $last, $upper, $lower, $left, $right, $restricted);	
	local (%sortby);
	
	if($in{'listnew'}) {
  		$days = 8;  
  		$new = &get_date(time() - ($days * 86400));
  		$in{'Date-gt'} = $new;
  		$in{'sb'} = 14; 
  		$in{'so'} = 'descend';
			}

	if ($in{'keyword'}) {
		$i = 0; 
		$in{'ma'} = "on";		
		foreach $column (@db_cols) {		
			if (($db_sort{$column} eq 'date') or &date_to_unix($in{'keyword'})) { $i++; next; }
			if ($i == $auth_user_field) { $i++; next; }
			push (@search_fields, $i);		
			$in{$column} = $in{'keyword'};
			$i++;
		}
	}
	else {					
		$i = 0;					
		foreach $column (@db_cols) {
			if ($in{$column}   =~ /^\>(.+)$/) { ($db_sort{$column} eq 'date') and (&date_to_unix($1) or return "Invalid date format: '$1'");
												push (@search_gt_fields, $i); $in{"$column-gt"} = $1; $i++; next; }
			if ($in{$column}   =~ /^\<(.+)$/) { ($db_sort{$column} eq 'date') and (&date_to_unix($1) or return "Invalid date format: '$1'");
												push (@search_lt_fields, $i); $in{"$column-lt"} = $1; $i++; next; }
			if ($in{$column}      !~ /^\s*$/) { ($db_sort{$column} eq 'date') and (&date_to_unix($in{$column}) or return "Invalid date format: '$in{$column}'");
												push(@search_fields, $i); $i++; next; }
			if ($in{"$column-gt"} !~ /^\s*$/) { ($db_sort{$column} eq 'date') and (&date_to_unix($in{"$column-gt"}) or return qq|Invalid date format: '$in{"$column-gt"}'|);
												push(@search_gt_fields, $i); }
			if ($in{"$column-lt"} !~ /^\s*$/) { ($db_sort{$column} eq 'date') and (&date_to_unix($in{"$column-lt"}) or return qq|Invalid date format: '$in{"$column-lt"}'|);
												push(@search_lt_fields, $i); }
			$i++;
		}
	}

	if (!@search_fields and !@search_gt_fields and !@search_lt_fields) {
		return "No search terms specified";
	}
		
	$in{'mh'} ?	($maxhits = $in{'mh'}) : ($maxhits = $db_max_hits);
	$in{'nh'} ? ($nh      = $in{'nh'}) : ($nh      = 1);
	$numhits = 0;

	($restricted = 1) if ($_[0] eq "view" and $auth_view_own and !$per_admin);
	($restricted = 1) if ($_[0] eq "mod"  and $auth_modify_own and !$per_admin);

	foreach $field (@search_fields) {
		my $tmpreg = "$in{$db_cols[$field]}";
		(!$in{'re'}) and ($tmpreg = "\Q$tmpreg\E");
		($in{'ww'})  and ($tmpreg = "\\b$tmpreg\\b");
		(!$in{'cs'}) and ($tmpreg = "(?i)$tmpreg");
		($in{$db_cols[$field]} eq "*") and ($tmpreg = ".*");	
		
		$regexp_func[$field] = eval "sub { m/$tmpreg/o }";
		$regexp_bold[$field] = $tmpreg;
	}

	$first = ($maxhits * ($nh - 1));
	$last  =  $first + $maxhits - 1;
	
	open (DB, "<$db_file_name") or &cgierr("error in search. unable to open database: $db_file_name.\nReason: $!");
	if ($db_use_flock) { flock(DB, 1); }	
	LINE: while (<DB>) {
		(/^#/)      and next LINE;
		(/^\s*$/)   and next LINE;
		$line = $_;	chomp ($line);		
		@values = &split_decode($line);

		next LINE if ($restricted and ($db_userid ne $values[$auth_user_field]));
		
		$key_match = 0;
		foreach $field (@search_fields) {
			$_ = $values[$field];	
			$in{'ma'} ?
				($key_match = ($key_match or &{$regexp_func[$field]})) :
			    (&{$regexp_func[$field]} or next LINE);
		}

		foreach $field (@search_gt_fields) {		
			$term = $in{"$db_cols[$field]-gt"};						
			if ($db_sort{$db_cols[$field]} eq "date") {
				$in{'ma'} ?
					($key_match = ($key_match or (&date_to_unix($values[$field])) > &date_to_unix($term))) :
					(&date_to_unix($values[$field]) > (&date_to_unix($term)) or next LINE);
			}
			elsif ($db_sort{$db_cols[$field]} eq 'alpha') {
				$in{'ma'} ?
					($key_match = ($key_match or ($values[$field] > $term))) :
					((lc($values[$field]) gt lc($term)) or next LINE);			
			}
			else {;			
				$in{'ma'} ?
					($key_match = ($key_match or ($values[$field] > $term))) :
					(($values[$field] > $term) or next LINE);
			}
		}

		foreach $field (@search_lt_fields) {
			$term = $in{"$db_cols[$field]-lt"};
			if ($db_sort{$db_cols[$field]} eq "date") {
				$in{'ma'} ?
					($key_match = ($key_match or (&date_to_unix($values[$field]) < &date_to_unix($term)))) :
					(&date_to_unix($values[$field]) < (&date_to_unix($term)) or next LINE);
			}
			elsif ($db_sort{$db_cols[$field]} eq 'alpha') {
				$in{'ma'} ?
					($key_match = ($key_match or ($values[$field] < $term))) :
					((lc($values[$field]) lt lc($term)) or next LINE);			
			}
			else {
				$in{'ma'} ?
					($key_match = ($key_match or ($values[$field] < $term))) :
					(($values[$field] < $term) or next LINE);
			}
		}

		if ($key_match || (!($in{'keyword'}) && !($in{'ma'}))) {			
			if (exists $in{'sb'}) {
				$sortby{(($#hits+1) / ($#db_cols+1))} = $values[$in{'sb'}];				
				push (@hits, @values); 
			}
			else {
				(($numhits >= $first) and ($numhits <= $last)) and push (@hits, @values);
			}
			$numhits++;		
		}
	}
	close DB;
	
	$numhits ? ($db_total_hits = $numhits) : ($db_total_hits = 0);
	($db_total_hits == 0) and return ("No matching records");

	if (exists $in{'sb'}) {	
		my ($sort_order, $sort_func);
		$in{'so'} ? ($sort_order = $in{'so'}) : ($sort_order = "ascend");
		$sort_func = "$db_sort{$db_cols[$in{'sb'}]}_$sort_order";		
		
		foreach $hit (sort $sort_func (keys %sortby)) {
			$first = ($hit * $#db_cols) + $hit; $last = ($hit * $#db_cols) + $#db_cols + $hit;			
			push (@sortedhits, @hits[$first .. $last]);
		}
		@hits = @sortedhits;
	}	

	if ($numhits > $maxhits) {	
		
		$next_url = $ENV{'QUERY_STRING'};
		$next_url =~ s/\&nh=\d+//;
		$next_hit = $nh + 1; $prev_hit = $nh - 1;

		$left  = $nh; $right = int($numhits/$maxhits) - $nh;		
		
		($left > 7)  ? ($lower = $left - 7) : ($lower = 1);
		($right > 7) ? ($upper = $nh + 7)   : ($upper = int($numhits/$maxhits) + 1);
		
		(7 - $nh >= 0) and ($upper = $upper + (8 - $nh));
		($nh > ($numhits/$maxhits - 7)) and ($lower = $lower - ($nh - int($numhits/$maxhits - 7) - 1));
		$db_next_hits = "";
		
		($nh > 1) and ($db_next_hits .= qq~<a href="$db_script_url?$next_url&nh=$prev_hit">[<<]</a> ~);
		for ($i = 1; $i <= int($numhits/$maxhits) + 1; $i++) {
			if ($i < $lower) { $db_next_hits .= " ... "; $i = ($lower-1); next; }			
			if ($i > $upper) { $db_next_hits .= " ... "; last; }
			($i == $nh) ?
				($db_next_hits .= qq~$i ~) :
				($db_next_hits .= qq~<a href="$db_script_url?$next_url&nh=$i">$i</a> ~);
			if (($i * $maxhits) >= $numhits) { last; }  
		}
		$db_next_hits .= qq~<a href="$db_script_url?$next_url&nh=$next_hit">[>>]</a> ~ unless ($nh == $i);
		
		if (exists $in{'sb'}) {			
			$first = ($maxhits * ($nh - 1)) * ($#db_cols+1);
			$last  =  $first + (($#db_cols+1) * $maxhits) - 1;		
			$last = $#hits if ($last > $#hits);
			@hits = @hits[$first .. $last];
		}
	}
	
	if ($db_bold and $in{'view_records'}) {
		for $i (0 .. (($#hits+1) / ($#db_cols+1)) - 1) {
			$offset = $i * ($#db_cols+1);
			foreach $field (@search_fields) {				
				$hits[$field + $offset] =~ s,(<[^>]+>)|($regexp_bold[$field]),defined($1) ? $1 : "<B>$2</B>",ge;
			}
		}
	}
	return ("ok", @hits);
}

sub admin_display {

	my ($message, @lines, $line);
	
	CASE: {

		$in{'new_username'}		and do {
				unless ((length($in{'new_username'}) >= 3) and (length($in{'new_username'}) <= 12) and ($in{'new_username'} =~ /^[a-zA-Z0-9]+$/)) {
					$message = "Invalid username: $in{'new_username'}. Must only contain letters and numbers and be less then 12 and greater then 3 characters.";
					last CASE;
				}
				unless ((length($in{'password'}) >= 3) and (length($in{'password'}) <= 12)) {
					$message = "Invalid password: '$in{'password'}'. Must be less then 12 and greater then 3 characters.";
					last CASE;
				}
				open (PASS, ">>$auth_pw_file") or &cgierr ("unable to open: $auth_pw_file.\nReason: $!");
					if ($db_use_flock) {
						flock(PASS, 2)  or &cgierr("unable to get exclusive lock on $auth_pw_file.\nReason: $!");
					}
				    my @salt_chars = ('A' .. 'Z', 0 .. 9, 'a' .. 'z', '.', '/');
					my $salt = join '', @salt_chars[rand 64, rand 64];
					my $encrypted = crypt($in{'password'}, $salt);			
					print PASS "$in{'new_username'}:$encrypted:$in{'per_view'}:$in{'per_add'}:$in{'per_del'}:$in{'per_mod'}:$in{'per_admin'}\n";
				close PASS;
				$message = "User: $in{'new_username'} created.";
				last CASE;
			};

		$in{'delete'}		and do {
				unless ($in{'username'}) {
					$message = "No username selected to delete";
					last CASE;
				}
				open (PASS, "<$auth_pw_file") or &cgierr ("unable to open: $auth_pw_file.\nReason: $!");
				if ($db_use_flock) { flock(PASS, 1)	}				
				@lines = <PASS>;
				close PASS;
				
				open (PASS, ">$auth_pw_file") or &cgierr ("unable to open: $auth_pw_file.\nReason: $!");
				if ($db_use_flock) {
					flock(PASS, 2)  or &cgierr("unable to get exclusive lock on $auth_pw_file.\nReason: $!");
				}
				my $found = 0;
				foreach $line (@lines) {
					($line =~ /^$in{'username'}:/) ?
						($found = 1) :
						print PASS $line;
				}
				close PASS;
				$found ?
					($message = "User: $in{'username'} deleted.") :
					($message = "Unable to find userid: $in{'username'} in password file.");
				last CASE;
			};

		($in{'username'} && !$in{'inquire'}) and do {
				open (PASS, "<$auth_pw_file") or &cgierr ("unable to open: $auth_pw_file.\nReason: $!");
				if ($db_use_flock) { flock(PASS, 1); }				
				@lines = <PASS>;
				close PASS;
				
				open (PASS, ">$auth_pw_file") or &cgierr ("unable to open: $auth_pw_file.\nReason: $!");
				if ($db_use_flock) {
					flock(PASS, 2)  or &cgierr("unable to get exclusive lock on $auth_pw_file.\nReason: $!");
				}
				my $found = 0;
				foreach $line (@lines) {
					if ($line =~ /^$in{'username'}:/) {
						my $password = (split (/:/, $line))[1];
						unless ($password eq $in{'password'}) {
						    my @salt_chars = ('A' .. 'Z', 0 .. 9, 'a' .. 'z', '.', '/');
							my $salt = join '', @salt_chars[rand 64, rand 64];
							$password = crypt($in{'password'}, $salt);
						}
						print PASS "$in{'username'}:$password:$in{'per_view'}:$in{'per_add'}:$in{'per_del'}:$in{'per_mod'}:$in{'per_admin'}\n";
						$found = 1;
					}
					else {
						print PASS $line;
					}
				}
				$in{'inquire'} = $in{'username'};
				$found ?
					($message = "User: $in{'username'} updated.") :
					($message = "Unable to find user: '$in{'username'}' in the password file.");
				last CASE;
			};
	};
	
	open (PASS, "<$auth_pw_file") or &cgierr ("unable to open: $auth_pw_file.\nReason: $!");
	if ($db_use_flock) { flock(PASS, 1); }	
	@lines = <PASS>;
	close PASS;

	my (@data, $user_list, $perm, $password);

	$user_list = qq~<select name="username"><option> </option>~;
	LINE: foreach $line (@lines) {
		$line =~ /^#/    and next LINE;
		$line =~ /^\s*$/ and next LINE;
		chomp $line;
		@data = split (/:/, $line);
		
		if ($in{'inquire'} and ($in{'username'} eq $data[0])) {
			$user_list .= qq~<option value="$data[0]" SELECTED>$data[0]</option>\n~;
			$perm = qq|
			  View <input type=checkbox name="per_view" value="1"     |; ($data[2] and $perm .= "CHECKED"); $perm .= qq|> 
		      Add <input type=checkbox name="per_add" value="1"       |; ($data[3] and $perm .= "CHECKED"); $perm .= qq|> 
			  Delete <input type=checkbox name="per_del" value="1"    |; ($data[4] and $perm .= "CHECKED"); $perm .= qq|> 
			  Modify <input type=checkbox name="per_mod" value="1" 	  |; ($data[5] and $perm .= "CHECKED"); $perm .= qq|>
			  Admin <input type=checkbox name="per_admin" value="1"   |; ($data[6] and $perm .= "CHECKED"); $perm .= qq|>|;
			$password = $data[1];
		}
		else {
			$user_list .= qq~<option value="$data[0]">$data[0]</option>\n~;	
		}
	}
	$user_list .= "</select>";

	if (!$perm) {
		$perm = qq|
		  View <input type=checkbox name="per_view" value="1"     |; ($auth_default_perm[0] and $perm .= "CHECKED"); $perm .= qq|> 
	      Add <input type=checkbox name="per_add" value="1"       |; ($auth_default_perm[1] and $perm .= "CHECKED"); $perm .= qq|> 
		  Delete <input type=checkbox name="per_del" value="1"    |; ($auth_default_perm[2] and $perm .= "CHECKED"); $perm .= qq|> 
		  Modify <input type=checkbox name="per_mod" value="1" 	  |; ($auth_default_perm[3] and $perm .= "CHECKED"); $perm .= qq|>
		  Admin <input type=checkbox name="per_admin" value="1"   |; ($auth_default_perm[4] and $perm .= "CHECKED"); $perm .= qq|>|;
	}			  
	&html_admin_display ($message, $user_list, $password, $perm);
}

sub signup {

	my $message;

	unless ((length($in{'userid'}) >= 3) and (length($in{'userid'}) <= 12) and ($in{'userid'} =~ /^[a-zA-Z0-9]+$/)) {
		$message = "Invalid userid: $in{'userid'}. Must only contain only letters and be less then 12 and greater then 3 characters.";
	}
	unless ((length($in{'pw'}) >= 3) and (length($in{'pw'}) <= 12)) {
		$message = "Invalid pw: '$in{'pw'}'. Must be less then 12 and greater then 3 characters.";
	}
	open (PASS, "<$auth_pw_file") or &cgierr ("unable to open: $auth_pw_file.\nReason: $!");
	if ($db_use_flock) { flock(PASS, 1); }
	while (<PASS>) {
		/^\Q$in{'userid'}\E:/ and ($message = "userid already exists. Please try another.");
	}
	close PASS;	
	if ($message) {
		&html_signup_form ($message);
		return;
	}

	open (PASS, ">>$auth_pw_file") or &cgierr ("unable to open: $auth_pw_file.\nReason: $!");
	if ($db_use_flock) {
		flock(PASS, 2)  or &cgierr("unable to get exclusive lock on $auth_pw_file.\nReason: $!");
	}
	srand( time() ^ ($$ + ($$ << 15)) );	# Seed Random Number
    my @salt_chars  = ('A' .. 'Z', 0 .. 9, 'a' .. 'z', '.', '/');
	my $salt        = join '', @salt_chars[rand 64, rand 64];
	my $encrypted   = crypt($in{'pw'}, $salt);			
	my $permissions = join (":", @auth_signup_permissions);
	
	print PASS "$in{'userid'}:$encrypted:$permissions\n";
	close PASS;
	
	&html_signup_success;
}

sub get_record {

	my ($key, $found, $line, @data, $field, $restricted);
	$key = $_[0];	
	$found = 0;
	#($restricted = 1) if ($auth_modify_own and !$per_admin);

	open (DB, "<$db_file_name") or &cgierr("error in get_records. unable to open db file: $db_file_name.\nReason: $!");
	if ($db_use_flock) { flock(DB, 1); }	
	LINE: while (<DB>) {
		(/^#/)      and next LINE;
		(/^\s*$/)   and next LINE;
		$line = $_;	chomp ($line);		
		@data = &split_decode($line);
		next LINE if ($restricted and ($db_userid ne $data[$auth_user_field]));
		if ($data[$db_key_pos] eq $key) {
			$found = 1;
			for ($i = 0; $i <= $#db_cols; $i++) {  # Map the array columns to a hash.
				$rec{$db_cols[$i]} = $data[$i];
			}
			last LINE;
		}
	}
	close DB;	
	$found ?
		(return %rec) :
		(return undef);
}

sub get_defaults {

	my (%default);

	foreach $field (keys %db_defaults) {
		$default{$field} =  $db_defaults{$field};
	}
	
	if ($db_key_track) {
		open (ID, "<$db_id_file_name") or &cgierr("error in get_defaults. unable to open id file: $db_id_file_name.\nReason: $!");
		if ($db_use_flock) { flock(ID, 1);	}	
		$default{$db_key} = <ID> + 1;	
		close ID;
	}
	return %default;
}


sub validate_record {

  my ($col, @input_err, $errstr, $err, $line, @lines, @data);	

  if ($in{'add_record'}) 	{		
    open (DB, "<$db_file_name") or &cgierr("error in validate_records. unable to open db file: $db_file_name.\nReason: $!");		
      if ($db_use_flock) { flock(DB, 1); }		
      LINE: while (<DB>) {
        (/^#/)      and next LINE;
        (/^\s*$/)   and next LINE;
        $line = $_; chomp ($line);
        @data = &split_decode($line);	
        if ($data[$db_key_pos] eq $in{$db_key}) {
          return "duplicate key error";
        }
      }
    close DB;
  }	

  foreach $col (@db_cols) {
    if ($in{$col} =~ /^\s*$/) {                            
      ($db_not_null{$col}) and                             
        push(@input_err, "$col (Can not be left blank)");  
    }
    else {                                                 
      ($db_valid_types{$col} && !($in{$col} =~ /$db_valid_types{$col}/)) and
        push(@input_err, "$col (Invalid format)");         
      (length($in{$col}) > $db_lengths{$col}) and
        push (@input_err, "$col (Too long. Max length: $db_lengths{$col})");
      if ($db_sort{$col} eq "date") {		
        push (@input_err, "$col (Invalid date format)") unless &date_to_unix($in{$col});
      }

   if ($db_censor) {
        foreach $dirty_word (@dirty_words) {
          if (lc($in{$col}) =~ /$dirty_word/) {
            if ($db_censor == 1) {
              push(@input_err, "$col (Includes a banned word -- $dirty_word)");
            }
            else {
              if ($db_censor == 2) { $replace = "***"; }
              elsif ($db_censor == 3) { 
                $replace = substr($dirty_word,0,1).("*" x (length($dirty_word)-2)).substr($dirty_word,length($dirty_word)-1,1); 
              } 
              elsif ($db_censor == 4) { 
                $replace = $dirty_word; $replace =~ s/a|e|i|o|u/\*/ig; 
              }
              elsif ($db_censor == 5) { 
                $replace = substr($dirty_word,0,1).("*" x (length($dirty_word)-1)); 
              } 
              else { 
                $replace = ("*" x (length($dirty_word)));
              }
              $in{$col} =~ s/$dirty_word/$replace/ig;
            }
          }
        }
      }

    }
  }
  if ($#input_err+1 > 0) {           
    foreach $err (@input_err) {	     
      $errstr .= "<li>$err";	     
    }
    return "<ul>$errstr</ul>";
  }
  else {
    return "ok";                     
  }
}


sub join_encode {

	my (%hash) = @_;
	my ($tmp, $col, $output);	

	foreach $col (@db_cols) {				
		$tmp = $hash{$col};
		$tmp =~ s/^\s+//g;				
		$tmp =~ s/\s+$//g;				
		$tmp =~ s/\Q$db_delim\E/~~/og;	
		$tmp =~ s/\n/``/g;				
		$tmp =~ s/\r//g;				
		$output .= $tmp . $db_delim;	
	}
	chop $output;		
	$output .= "\n";	
	return $output;
}

sub split_decode {

	my ($input) = shift;
	$input =~ s/\Q$db_delim\E$/$db_delim /o; 
	my (@array) = split (/\Q$db_delim\E/o, $input);
	for ($i = 0; $i <= $#array; $i++) {
		$array[$i] =~ s/~~/$db_delim/og;	
		$array[$i] =~ s/``/\n/g;			
	}	
	return @array;
}

sub build_select_field {

	my ($column, $value) = @_;	
	my (@fields, $ouptut);

	@fields = split (/\,/, $db_select_fields{$column});
	if ($#fields == -1) {
		$output = "Error building select field: No select fields specified in config for field '$column'!";
	}
	else {
		$output = qq|<SELECT NAME="$column"><OPTION>---|;
		foreach $field (@fields) {
			$field eq $value ?
				($output .= "<OPTION SELECTED>$field\n") :
				($output .= "<OPTION>$field");
		}
		$output .= "</SELECT>";
	}
	return $output;
}

sub build_select_field_from_db {

	my ($column, $value, $name) = @_;
	my (@fields, $field, @selectfields, @lines, $line, $ouptut);
	my ($fieldnum, $found, $i) = 0;
	
	$name || ($name = $column);
	
	for ($i = 0; $i <= $#db_cols; $i++) {
		if ($column eq $db_cols[$i]) {
			$fieldnum = $i; $found = 1;
			last;
		}
	}
	if (!$found) {
		return "Error building select field: No fields specified!";
	}

	open (DB, "<$db_file_name") or &cgierr("unable to open $db_file_name. Reason: $!");
	if ($db_use_flock) { flock(DB, 1); }
	LINE: while (<DB>) {		
		next if /^#/;
		next if /^\s*$/;
		$line = $_;
		chomp ($line);		
		@fields = &split_decode ($line);
		if (!(grep $_ eq $fields[$fieldnum], @selectfields)) {
			push (@selectfields, $fields[$fieldnum]);
		}
	}
	close DB;
	
	$output = qq|<SELECT NAME="$name"><OPTION>---|;
	foreach $field (sort @selectfields) {
		($field eq $value) ?
			($output .= "<OPTION SELECTED>$field") :
			($output .= "<OPTION>$field");
	}
	$output .= "</SELECT>";

	return $output;
}

sub build_checkbox_field {

	my ($column, $values) = @_;

	if (!$db_checkbox_fields{$column}) {
		return "Error building checkboxes: No checkboxes specified in config for field '$column'";
	}	
	
	my @names  = split (/,/, $db_checkbox_fields{$column});
	my @values = split (/\Q$db_delim\E/, $values);
	my ($name, $output);	

	foreach $name (@names) {
		(grep $_ eq $name, @values) ?
			($output .= qq!<INPUT TYPE="CHECKBOX" NAME="$column" VALUE="$name" CHECKED> $name\n!) :
			($output .= qq!<INPUT TYPE="CHECKBOX" NAME="$column" VALUE="$name"> $name\n!);
	}
	return $output;
}

sub build_radio_field {

	my ($column, $value) = @_;
	my (@buttons, $button, $output);

	@buttons = split (/,/, $db_radio_fields{$column});
	
	if ($#buttons == -1) {
		$output = "Error building radio buttons: No radio fields specified in config for field '$column'!";
	}
	else {
		foreach $button (@buttons) {
			$value =~ /^\Q$button\E$/ ?
				($output .= qq|<INPUT TYPE="RADIO" NAME="$column" VALUE="$button" CHECKED> $button \n|) :
				($output .= qq|<INPUT TYPE="RADIO" NAME="$column" VALUE="$button"> $button \n|);
		}
	}	
	return $output;
}

sub array_to_hash {

	my($hit, @array) = @_;
	my(%hash);
	 
	for ($j = 0; $j <= $#db_cols; $j++) {
		$hash{$db_cols[$j]} = $array[$hit * ($#db_cols+1) + $j];
	}	
	return %hash;
}

sub build_html_record {

	my (%rec) = @_;
	my ($output, $field);
	
	$output = "<p><table border=0 width=450>";
	foreach $field (@db_cols) {
		next if ($db_form_len{$field} == -1);
		$output .= qq~<tr><td align=right valign=top width=20%><$font>$field:</font></td>
		                <td width=80%><$font>$rec{$field}</font></td></tr>
					~;
	}
	$output .= "</table></p>\n";
	return $output;
}

sub build_html_record_form {

	my (%rec) = @_;
	my ($output, $field);
	
	$output = "<p><table border=0>";
	foreach $field (@db_cols) {
		if ($db_select_fields{$field}) {      $output .= "<tr><td align=right valign=top width=20%><$font>$field:</font></td><td width=80%>" . &build_select_field($field, $rec{$field}) . "</td></tr>"; }
		elsif ($db_radio_fields{$field}) {    $output .= "<tr><td align=right valign=top width=20%><$font>$field:</font></td><td width=80%>" . &build_radio_field($field, $rec{$field}) . "</td></tr>"; }
		elsif ($db_checkbox_fields{$field}) { $output .= "<tr><td align=right valign=top width=20%><$font>$field:</font></td><td width=80%>" . &build_checkbox_field ($field, $rec{$field}) . "</td></tr>"; }
		elsif ($db_form_len{$field} =~ /(\d+)x(\d+)/) { 
											  $output .= qq~<tr><td align=right valign=top width=20%><$font>$field:</font></td><td width=80%><textarea name="$field" cols="$1" rows="$2">$rec{$field}</textarea></td></tr>~; }
		elsif ($db_form_len{$field} == -1) {  $output  = qq~<input type=hidden name="$field" value="$rec{$field}">$output~; }
		elsif ($db_form_len{$field} == -2) {  $per_admin ? ($output .= qq~<tr><td align=right valign=top width=20%><$font>$field:</font></td><td width=80%><input type=text name="$field" value="$rec{$field}" maxlength="$db_lengths{$field}"></td></tr>~) :
														   ($output  = qq~<input type=hidden name="$field" value="$rec{$field}">$output~); }
		else  { 							  $output .= qq~<tr><td align=right valign=top width=20%><$font>$field:</font></td><td width=80%><input type=text name="$field" value="$rec{$field}" size="$db_form_len{$field}" maxlength="$db_lengths{$field}"></td></tr>~; }
	}
	$output .= "</table></p>\n";
	return $output;
}		
		
sub get_time {

	my ($sec, $min, $hour, $day, $mon, $year, $dweek, $dyear, $daylight) = localtime(time());
	($sec < 10)  and ($sec = "0$sec");
	($min < 10)  and ($min = "0$min");
	($hour < 10) and ($hour = "0$hour");
	
	return "$hour:$min:$sec";
}

sub get_date {

    $time1 = @_[0];
    ($time1) or ($time1 = time());
    my ($sec, $min, $hour, $day, $mon, $year, $dweek, $dyear, $daylight) = localtime($time1);
    my (@months) = qw!Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec!;
	($day < 10) and ($day = "0$day");
	$year = $year + 1900;
    
    return "$day-$months[$mon]-$year";

}

sub date_to_unix {

    my ($date)   = $_[0]; 
    my (%months) = ("Jan" => 0, "Feb" => 1, "Mar" => 2, "Apr" => 3, "May" => 4, "Jun" => 5, 
                    "Jul" => 6, "Aug" => 7, "Sep" => 8, "Oct" => 9, "Nov" => 10,"Dec" => 11);
	my ($time);
    my ($day, $mon, $year) = split(/-/, $_[0]);
    unless ($day and $mon and $year)  { return undef; }
    unless (defined($months{$mon}))   { return undef; }    

	use Time::Local;
    eval {		
		$day = int($day); $year = int($year) - 1900; 
        $time = timelocal(0,0,0,$day, $months{$mon}, $year);
    };
    if ($@) { return undef; } # Could return 0 if you want.
    return ($time); 
}

sub alpha_ascend  { lc($sortby{$a}) cmp lc ($sortby{$b}) }
sub alpha_descend { lc($sortby{$b}) cmp lc ($sortby{$a}) }
sub numer_ascend  { $sortby{$a} <=> $sortby{$b} }
sub numer_descend { $sortby{$b} <=> $sortby{$a} }
sub date_ascend   { &date_to_unix($sortby{$a}) <=> &date_to_unix($sortby{$b}) }
sub date_descend  { &date_to_unix($sortby{$b}) <=> &date_to_unix($sortby{$a}) }

sub parse_form {
# --------------------------------------------------------
  my (%in);
  my ($buffer, $pair, $name, $value); 

  PAIR: foreach $name ($query->param()) {
    $value = $query->param("$name"); 
    $name =~ tr/+/ /;
    $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/<!--(.|\n)*-->//g;
    if ($value eq "---") { next PAIR; }
	unless ($value) { next PAIR; }
    (exists $in{$name}) ?
      ($in{$name} .= "~~$value") :
      ($in{$name} = $value);
  }
  return %in;
}

sub cgierr {

	if (!$html_headers_printed) {
		print "Content-type: text/html\n\n";
		$html_headers_printed = 1;
	}
	print "<PRE>\n\nCGI ERROR\n==========================================\n";
	$_[0]      and print "Error Message       : $_[0]\n";	
	$0         and print "Script Location     : $0\n";
	$]         and print "Perl Version        : $]\n";	
	$db_setup  and print "Setup File          : $db_setup.cfg\n";
	$db_userid and print "User ID             : $db_userid\n";
	$db_uid    and print "Session ID          : $db_uid\n";
	
	print "\nForm Variables\n-------------------------------------------\n";
	foreach $key (sort keys %in) {
		my $space = " " x (20 - length($key));
		print "$key$space: $in{$key}\n";
	}
	print "\nEnvironment Variables\n-------------------------------------------\n";
	foreach $env (sort keys %ENV) {
		my $space = " " x (20 - length($env));
		print "$env$space: $ENV{$env}\n";
	}
	print "\n</PRE>";
	exit -1;
}

sub urlencode {

  my($toencode) = shift;
  $toencode =~ s/([^a-zA-Z0-9_\-.])/uc sprintf("%%%02x",ord($1))/eg;
  return $toencode;

}